import { select, json, geoPath, zoom, event, geoAlbersUsa } from 'd3';
import { feature } from 'topojson';

const svg = select('svg');

const projection = geoAlbersUsa();
const pathGenerator = geoPath();
const g = svg.append('g');

var div = d3.select("body").append("div")   
        .attr("class", "tooltip")               
        .style("opacity", 0);

var tooltip = d3.select("body")
    .append("div")
    .style("position", "absolute")
    .style("z-index", "10")
    .style("visibility", "hidden")

g.call(zoom().on('zoom', () => {
  g.attr('transform', event.transform);
}));
g.append("path")
      .attr("class", "state-borders");
	json('https://unpkg.com/us-atlas@1/us/10m.json')
    .then(data => {
      const countries = feature(data, data.objects.states);
      //console.log(countries);
      g.selectAll('path').data(countries.features)
        .enter().append('path')
          .attr('class', 'states')
          .attr('fill','#e4ffa8')
          .attr('d', pathGenerator);
    d3.csv("data.csv").then(function(data) {
              //console.log(data)    
        g.selectAll("circle")
              .data(data)
          .enter().append("circle")
            .attr("cx", function(d) {return projection([+d.lat, +d.lon])[0];})
            .attr("cy", function(d) {return projection([+d.lat, +d.lon])[1];})
            .attr("r", 2)
              .style("fill", "red")	
              .style("opacity", 0.3)
          .on("mouseover", function (d){
            d3.select(this)
              .attr('fill','red')
            tooltip.html(d)
              .transition(500)
              .style("left",(d3.event.pageX-20) +"px")  
              .style("top",(d3.event.pageY-20)+"px")
              .style("bottom",(d3.event.pageY+20)+"px")
              .style("right",(d3.event.pageX+20)+"px")
              .style("visibility", "visible")    
              .style("pointer-events", "none")
              .text(d.primary_type);
             })
          .on("mouseout", function (d){
            d3.select(this)
              .attr('fill',"#ffcb3d")
            d3.select("#reading").remove()
              tooltip
                .style("visibility", "hidden")});
      g.selectAll("circle")
        .transition()
          .duration(750)
          .attr("transform", function(d) {
            var t = d3.transform(d3.select(this).attr("transform")).translate;
        		//maintain aold marker translate 
            return "translate(" + t[0] +","+ t[1] + ")scale("+1/scale+")";
        		//inverse the scale of parent
      		});
      g.selectAll("circle")
        .attr("transform", function(d) {
          var t = d3.transform(d3.select(this).attr("transform")).translate;
          console.log(t)
          return "translate(" + t[0] +","+ t[1] + ")scale("+1+")";
    			});   
      
      });
});